//
//  AFTimer.m
//
//  Created by Ariel Feinerman on 1/28/10.
//  Copyright 2010 Alice Software Inc. All rights reserved.
//

#import "AFTimer.h"


@implementation AFTimer

- (id) initWithTarget: (id <AFTimer>) theTarget {
	
	if (![theTarget respondsToSelector: @selector(change)]) {
		[self release];
		return nil;
	}
	
	if (self = [super init]) {
		time = 1.0 / 60.0;
		target = theTarget;
		[self begin];
	}
	
	return self; 
}

- (BOOL) setTarget: (id <AFTimer>) theTarget {
	
	if ([theTarget respondsToSelector: @selector(change)]) {
		target = theTarget;
		return YES;
	}
	return NO;
}

- (void) fire: (NSTimer *) theTimer {
	
	[target change];
}

- (void) begin {
	
	if (timer) { 
		[self stop];
	}
	
	timer = [NSTimer timerWithTimeInterval: time 
									target: self 
								  selector: @selector(fire:) 
								  userInfo: nil 
								   repeats: YES];
	
	[[NSRunLoop currentRunLoop] addTimer: timer forMode: NSDefaultRunLoopMode];
    [[NSRunLoop currentRunLoop] addTimer: timer forMode: NSEventTrackingRunLoopMode];
}

- (void) stop {
	
	[timer invalidate]; 
	timer = nil;
}

@end